%clear variables;close all;clc
[X,Xt] = xlsread('Study1input\Study1_text.xls'); %#ok<XLSRD> % loads raw data (992 participants, 9 columns)
% X is a 992 x 9 matrix of numbers
% Xt is a corresponding 992 x 9 matrix of texts
%% Submit batches to ChatGPT API
key
run_api=0;

if run_api==1 % if this flag == 1, then loop through the batches as described in the paper
    import matlab.net.* matlab.net.http.* matlab.net.http.io.*
    key % read the private key

    header = [HeaderField('Content-Type', 'application/json')
        HeaderField('DataTimeout', 10)
        HeaderField('ResponseTimeout', 10)
        HeaderField('Authorization', api_key)]';
    uri = URI('https://api.openai.com/v1/chat/completions');

    idxr100=[   420    94   594   468   691   695   634    34    69   318   527   650   405   814   713   961   528   323   105   607   773   421    91   265   153   279   437   523   454   869   514   937   633   951   239   671   287   667   690 ...
        68   253   223   663   838   342   775   670     7   598   384   909     2   459   421   458   764   320   779   468    36   175   716   470   152   339   603   191   733   241   911   267   760   188   286    91   572   678   543 ...
        423   640   643   674   631   938   208   704   235   119   603   447   456   657   765   348   657   413   836   827   255   609]; % 100 random indices

    for i=5001:5400 % 1000 batches
        for j=1:9 % loop over 9 interfaces
            idxr=ceil(992*rand(100,1)); % random indices of comments
            a = Xt(idxr,j); % random comments

            text=[];
            for i2=1:size(a,1) % loop over individual comments
                line=char(a(i2));
                if ~isempty(line)
                    text=[text line newline];
                end
            end

            unicode=double(text);
            unicode_rm=find(unicode>=123 | unicode <=31) ;
            text(unicode_rm)=' ';

            if ismember(i,1:200) % 1
                prompt = ['These text messages are obtained from a textbox in a questionnaire about nine augmented-reality interfaces for pedestrians who interact with an automated vehicle. The automated vehicle could either stop (yield) or maintain speed (not yield) for the pedestrian. The augmented-reality interfaces were presented in the form of videos. The textbox asked: "Please add a few words to justify your choices above (e.g., comment on the shape, colour, functionality, and the clarity of the interface)". I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,201:400) % 2
                prompt = ['These text messages are obtained from a textbox in a questionnaire about nine augmented-reality interfaces for pedestrians who interact with an automated vehicle. The augmented-reality interfaces were presented in the form of videos. The textbox asked: "Please add a few words to justify your choices above (e.g., comment on the shape, colour, functionality, and the clarity of the interface)". I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,401:600) % 3
                prompt = ['These text messages are obtained from a textbox in a questionnaire about nine augmented-reality interfaces for pedestrians who interact with an automated vehicle. The textbox asked: "Please add a few words to justify your choices above (e.g., comment on the shape, colour, functionality, and the clarity of the interface)". I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,601:800) % 4
                prompt = ['These text messages are obtained from a textbox in a questionnaire about nine augmented-reality interfaces for pedestrians who interact with an automated vehicle. The textbox asked: "Please add a few words to justify your choices above". I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,801:1000) % 5
                prompt = ['These text messages are obtained from a textbox in a questionnaire about nine augmented-reality interfaces for pedestrians who interact with an automated vehicle. The textbox asked: "Please add a few words". I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,1001:1200) % 6
                prompt = ['These text messages are obtained from a textbox in a questionnaire about nine augmented-reality interfaces for pedestrians who interact with an automated vehicle. I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,1201:1400) % 7
                prompt = ['These text messages are obtained from a textbox in a questionnaire about nine interfaces for pedestrians who interact with an automated vehicle. I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,1401:1600)
                prompt = ['These text messages are obtained from a textbox in a questionnaire about interfaces for pedestrians who interact with an automated vehicle. I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,1601:1800)
                prompt = ['These text messages are obtained from a textbox in a questionnaire about interfaces for pedestrians who interact with a vehicle. I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,1801:2000)
                prompt = ['These text messages are obtained from a textbox in a questionnaire about interfaces for pedestrians. I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,2001:2200)
                prompt = ['These text messages are obtained from a textbox in a questionnaire about interfaces for automated driving. I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,2201:2400)
                prompt = ['These text messages are obtained from a textbox in a questionnaire. I need you to provide a single sentiment rating about the interface being discussed in the comments, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,2401:2600)
                prompt = ['These text messages are obtained from a textbox in a questionnaire. I need you to provide a single sentiment rating about the interface being discussed, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,2601:2800)
                prompt = ['These text messages are obtained from a textbox in a questionnaire. I need you to provide a single sentiment rating about the interface, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,2801:3000)
                prompt = ['These text messages are obtained from a textbox. I need you to provide a single sentiment rating about the interface, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,3001:3200)
                prompt = ['These text messages are obtained from a textbox. I need you to provide a single sentiment rating, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,3201:3400)
                prompt = ['These are text messages. I need you to provide a single sentiment rating, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,3401:3600)
                prompt = ['I need you to provide a single sentiment rating about the text messages, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,3601:3800)
                prompt = ['I need you to provide a single sentiment rating about the texts, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,3801:4000)
                prompt = ['Provide a single sentiment rating about the texts, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,4001:4200)
                prompt = ['Provide a single rating about the texts, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,4201:4400)
                prompt = ['Rate the texts, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,4401:4600) % 23
                prompt = ['Rate texts, from 1 to 100. Only report a single number between 1 and 100, rounded to two decimals. no text!: ' newline];
            elseif ismember(i,4601:4800) % 24
                prompt = ['The comments below were obtained from respondents in an online survey about an AR interface in a road-crossing scenario. If you read the comments below, what is the quality of the interface on a scale from 1 = bad to 10 = good? Only report a number between 1 and 10. Round to two decimals ' newline];
            elseif ismember(i,4801:5000) % 25
                prompt = ['The comments below were obtained from respondents in an online survey about an AR interface in a road-crossing scenario. If you read the comments below, what is the quality of the interface on a scale from 1 = bad to 100 = good? Only report a number between 1 and 100. Round to two decimals ' newline];
            elseif ismember(i,5001:5200) % 26
                prompt = ['The comments below were obtained from respondents in an online survey about an AR interface in a road-crossing scenario. If you read the comments below, what is the quality of the interface on a scale from 1 = bad to 10 = good? Only report a number between 1 and 10. Round to two decimals ' newline];
                idxr=idxr100(ceil(100*rand(100,1))); % sort the 100 random indices in random order
                % in this analysis we submit the same 100 texts all the time, but in different order
            elseif ismember(i,5201:5400) % 27
                prompt = ['The comments below were obtained from respondents in an online survey about an AR interface in a road-crossing scenario. If you read the comments below, what is the quality of the interface on a scale from 1 = bad to 100 = good? Only report a number between 1 and 100. Round to two decimals ' newline];
                idxr=idxr100(ceil(100*rand(100,1))); % sort the 100 random indices in random order
                % in this analysis we submit the same 100 texts all the time, but in different order
            end

            prompt=[prompt text];

            body = JSONProvider(struct('model', 'gpt-3.5-turbo','temperature',0,'n',1,'messages', {{struct('role', 'user','content', prompt')}}));

            try
                response = RequestMessage('post', header, body).send(uri.EncodedURI);

                save(['Response_AR_May2023_992g_interface_' num2str(j) '_batch_' num2str(i)],'response','prompt','idxr')
                disp(['Response_AR_May2023_992g_interface_' num2str(j) '_batch_' num2str(i)])
                response_text = response.Body.Data.choices.message.content;
                disp(response_text);
            catch error
            end
        end
    end
    %% Extract scores from ChatGPT outputs

    Score=NaN(9,5400);
    Counter=[0 0 0];
    for j=1:9 % loop over 9 interfaces
        disp(j)
        for i=4401:4600 % loop over batches
            try
                load(['Response_AR_May2023_992g_interface_' num2str(j) '_batch_' num2str(i)])
                response_text = response.Body.Data.choices.message.content;
                response_text=response_text(ismember(response_text,[46 48:57])); % only retain numbers https://en.wikipedia.org/wiki/List_of_Unicode_characters
                dot=find(response_text==46);
                if length(dot)>1
                    dot =dot(2:end);
                    response_text(dot)=[]; %throw away extra dots
                end
                Score(j,i)=str2double(response_text);

                if isnan(Score(j,i))
                    disp('No response')
                    Counter(1)=Counter(1)+1;
                    disp([j i])
                    disp( response.Body.Data.choices.message.content)
                end
                if   Score(j,i)>100
                    disp('Score > 100')
                    Counter(2)=Counter(2)+1;
                    disp([j i])
                    disp( response.Body.Data.choices.message.content)
                end
            catch error
                Counter(3)=Counter(3)+1;

            end
        end % batch loop
    end % interface loop
end
%%
Score = xlsread('Study1output_bootstrapping\Scores_from_bootstrapping.xlsx')'; %#ok<XLSRD>
si=1:200:5400;
ei=si+199;
cc=NaN(length(si),3);
NN=NaN(length(si),9);
M=NaN(length(si),9);
SD=NaN(length(si),9);

v3 = mean(vaderSentimentScores(documents))';

for i=1:length(si) % loop over the different prompts
    v1=mean(X)'; % composite score, as reported in Tabone et al. (2023)
    v2=mean(Score(:,si(i):ei(i)),2,'omitnan'); % ChatGPT sentiment score
    cc(i,1)=corr(v1,v2); % correlation coefficient between composite score and ChatGPT sentiment score
    cc(i,2)=corr(v1,v3); % correlation coefficient between composite score and Vader sentiment score
    cc(i,3)=corr(v2,v3); % correlation coefficient between ChatGPT sentiment score and Vader sentiment score
    NN(i,:)=sum(~isnan(Score(:,si(i):ei(i))),2); % sample size
    M(i,:)=v2;
    SD(i,:)=std(Score(:,si(i):ei(i)),[],2,'omitnan');
end
%%
i=7;

v1=mean(X)'; % composite score, as reported in Tabone et al. (2023)
v2=mean(Score(:,si(i):ei(i)),2,'omitnan'); % ChatGPT score
disp(corr(v1,v2))
interfaces={'Augmented zebra crossing'
    'Planes on vehicle'
    'Conspicious looming planes'
    'Field of safe travel'
    'Fixed pedestrian lights'
    'Virtual fence'
    'Phantom car'
    'Nudge HUD'
    'Pedestrian lights HUD'};

cm=[                     0                         0                         1 % matrix of colors
    1                         0                         0
    0                         1                         0
    0                         0         0.172413793103448
    1         0.103448275862069         0.724137931034483
    1         0.827586206896552                         0
    0         0.344827586206897                         0
    0.517241379310345         0.517241379310345                         1
    0.620689655172414         0.310344827586207         0.275862068965517];

figure
for i = 1:9 % loop over 9 interfaces
    scatter1 = scatter(v1(i),v2(i), 400, 'markerfacecolor', cm(i, :),  'markeredgecolor', cm(i, :));
    hold on;
    grid on;
    scatter1.MarkerFaceAlpha = 0.8;
    text(v1(i) + 0.02, v2(i), char(interfaces(i)), 'horizontalalignment', 'left', 'fontsize', 16)
end
set(gca,'fontsize', 20)
axis square
xlabel('Composite score of human responses to rating scales (\it{z}\rm-score)','fontsize', 20)
ylabel('Sentiment score based on ChatGPT analysis of textbox responses (1-100)','fontsize', 20)
