clear variables;close all;clc
tic
[X,Xt] = xlsread('Study1input\Study1_text.xls'); %#ok<XLSRD> % loads raw data (992 participants, 9 columns)
% X is a 992 x 9 matrix of numbers
% Xt is a corresponding 992 x 9 matrix of texts
key % read the private key
%% Submit batches to ChatGPT API
import matlab.net.* matlab.net.http.* matlab.net.http.io.*

header = [HeaderField('Content-Type', 'application/json')
    HeaderField('Authorization', api_key)]';
uri = URI('https://api.openai.com/v1/chat/completions');

si=1; % startindex
ei=100; %endindex

i=1;j=1;

a= Xt(si(i):ei(i),j); % text
b = X(si(i):ei(i),1);

text=[];
K=0:0.1:2;

run_api=0;

if run_api==1 % if this flag ==1, then loop through the batches as described in the paper

    for i2=1:size(a) % loop over individual comments
        line=char(a(i2));
        if ~isempty(line)
            text=[text line newline];
        end
    end

    for k=1:length(K)
        prompt = ['Looking at the comments, score the interface, from 1 to 100. Only report a number between 1 and 100, rounded to two decimals' newline];
        prompt=[prompt text];

        body = JSONProvider(struct(...
            'model', 'gpt-3.5-turbo',...
            'temperature',K(k),...
            'n',100,...
            'messages', {{
            struct(...
            'role', 'user',...
            'content', prompt'...
            )
            }}...
            ));
        response = RequestMessage('post', header, body).send(uri.EncodedURI);
        save(['Response_AR_6b_mar_2023_4_992_randomness_' num2str(k) '_comments_' num2str(si(i)) '_to_' num2str(ei(i))],'response','prompt')
        try
            disp(['Batch' num2str(si(i)) '_to_' num2str(ei(i))])
            response_text = response.Body.Data.choices(1).message.content;
            disp(response_text);
        catch error
            pause
        end
    end

end

%% Extract scores from ChatGPT outputs

Score=NaN(length(K),100);

for k=1:length(K)

    load(['Study1output_randomness\Response_AR_6b_mar_2023_4_992_randomness_' num2str(k) '_comments_' num2str(si(i)) '_to_' num2str(ei(i))])
    if isequal(response.StatusCode,'OK')
        n=length(response.Body.Data.choices);
        for l=1:n
            response_text0 = response.Body.Data.choices(l).message.content;
            response_text =response_text0(ismember(response_text0,[46 48:57])); % only retain numbers https://en.wikipedia.org/wiki/List_of_Unicode_characters

            dot=find(response_text==46); % index of the dot
            if length(dot)>1
                dot =dot(2:end);
                response_text(dot)=[]; %throw away extra dots
            end

            Score(k,l)=str2double(response_text);
            if isnan(Score(k,l)) || Score(k,l)<1 || Score(k,l)>100
                disp([k l])
                disp(response_text0)
                Score(k,l)=NaN;
            end % end of loop of reps
        end % end of statuscode ok
    end
end
%%
close all
opengl hardware
M=nanmean(Score,2)';
SD=nanstd(Score,[],2)';

figure
plot(K,M,'ko-','Linewidth',3,'markersize',17)
hold on
grid on

plot(K,M+SD,'ko--','linewidth',3,'markersize',17)
plot(K,M-SD,'ko--','linewidth',3,'markersize',17)
legend('Mean','Mean ± SD','location','northwest')
xlabel('Temperature parameter')
ylabel('Sentiment score from ChatGPT text analysis (1–100)')
set(gca,'TickDir','out')
set(gca,'TickDir','out','LooseInset',[0.01 0.01 0.01 0.01],'fontsize',28)
set(gcf,'WindowState','maximized');
print(gcf,'Figure4.png','-dpng','-r600');
print(gcf,'Figure4.eps','-deps','-r600');
