clear variables;close all;clc

import matlab.net.* matlab.net.http.* matlab.net.http.io.*
key
header = [HeaderField('Content-Type', 'application/json')
    HeaderField('Authorization', api_key)]';
uri = URI('https://api.openai.com/v1/chat/completions');

%for j=1:10 % loop over 9 interfaces and Baseline condition
for j=6 % only fence
    if ismember(j,1:9)
        files=dir(['Study2input\' num2str(j) '\*.txt']);
    elseif j==10
        files=dir('Study2input\Baseline\*.txt');
    end
    prompt = ['Looking at the participants'' responses, provide a summary with specifics of the interface' newline];
    text_all=[];
    for i=1:length(files) % loop over participants
        if ismember(j,1:9)
            text=fileread(['Study2input\' num2str(j) '\' files(i).name]);
        elseif j==10
            text=fileread(['Study2input\Baseline\' files(i).name]);
        end
        text_all=[text_all newline ['Interview with participant number ' num2str(i) ': '] newline text];
    end
    prompt=[prompt newline text_all];
    body = JSONProvider(struct('model','gpt-3.5-turbo-16k','temperature',0,'n',1,'messages', {{struct('role', 'user','content', prompt')}}));
    response = RequestMessage('post', header, body).send(uri.EncodedURI);
    save(['Study2_gpt-35-turbo-16k_interface_' num2str(j) '_file_' num2str(i)],'response','prompt')
    response_text = response.Body.Data.choices.message.content;
    disp(['Interface ' num2str(j) ', File: ' num2str(i)])
    disp(response_text);
end
