clear variables;close all;clc

import matlab.net.* matlab.net.http.* matlab.net.http.io.*
key % read the private key
header = [HeaderField('Content-Type', 'application/json')
    HeaderField('Authorization', api_key)]';
uri = URI('https://api.openai.com/v1/chat/completions');

%% Sending Interviews to API

files=dir(['Study2input\' num2str(6) '\*.txt']);
for i=1:length(files)
    text=fileread(['Study2input\' num2str(6) '\' files(i).name]);
    import matlab.net.*

    prompt = ['This is an interview between an experimenter and a participant, about an augmented-reality interface:' newline];
    prompt = [prompt text]; %#ok<AGROW>
    prompt = [prompt newline newline newline 'Now, count how many times each of the following 38 characteristics is mentioned; avoid false positives. For example, if the experimenter asks about the participant''s wellbeing, this counts as 1 mention in category 1. Report your answer as e.g., "1: 1, 2: 3, 3: 1, 4: 0, 5: 0, 6: 1, 7: 0, 8: 2, ..., 37: 1, 38: 0", nothing else:']; %#ok<AGROW>
    prompt = [prompt newline ...
        '1:	Experimenter: Wellbeing monitoring' newline ...
        '2:	Experimenter: Thoughts on interface' newline ...
        '3:	Experimenter: Preference between interfaces' newline ...
        '4:	Experimenter: Clarification/follow-up question' newline ...
        '5:	Participant: No preference between green and red' newline ...
        '6:	Participant: Walls inhibited visibility' newline ...
        '7:	Participant: Relied on the interface more than the car/interface influenced decision' newline ...
        '8:	Participant: Walls gave a safe feeling' newline ...
        '9:	Participant: Interface clear' newline ...
        '10: Participant: Interface intuitive' newline ...
        '11: Participant: Green preferred' newline ...
        '12: Participant: Interface not intuitive/counterintuitive/confusing' newline ...
        '13: Participant: Red preferred' newline ...
        '14: Participant: Interface salient/large' newline ...
        '15: Participant: Interface safe' newline ...
        '16: Participant: Relied on the car more than the interface/interface did not affect decision' newline ...
        '17: Participant: One trial needed for understanding' newline ...
        '18: Participant: Interface easy' newline ...
        '19: Participant: Interface too large' newline ...
        '20: Participant: Red not intuitive/counterintuitive/confusing' newline ...
        '21: Participant: Interface not safe' newline ...
        '22: Participant: Walls provided false safety' newline ...
        '23: Participant: Interface had too many signals/too much going on' newline ...
        '24: Participant: Bad that interface did not explicitly relate to the approaching car' newline ...
        '25: Participant: Felt confident' newline ...
        '26: Participant: Realistic' newline ...
        '27: Participant: Unclear/gibberish' newline ...
        '28: Participant: Green intuitive' newline ...
        '29: Participant: Red is counterintuitve because it shows a zebra' newline ...
        '30: Participant: Good that the interface was not attached to the approaching car' newline ...
        '31: Participant: Liked the interface' newline ...
        '32: Participant: Did not feel comfortable with the interface' newline ...
        '33: Participant: More than one trial needed for understanding' newline ...
        '34: Participant: Red is counterintuive because wall is not a barrier for the car' newline ...
        '35: Participant: Trusted the interface' newline ...
        '36: Participant: Did not trust the interface' newline ...
        '37: Participant: Did not like the interface' newline ...
        '38: Participant: Interface was annoying']; %#ok<AGROW>

    body = JSONProvider(struct('model','gpt-4','temperature',0,'n',1,'messages', {{struct('role', 'user','content', prompt')}}));
    response = RequestMessage('post', header, body).send(uri.EncodedURI);
    response_text = response.Body.Data.choices.message.content;
    disp(response_text);
end
